'use strict';

/**
 * Created by x.Laoxu on 12/18/15.
 */

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _hasWebp = function hasWebp(callback) {
    var handleOnLoad = function handleOnLoad(support) {
        return function () {
            _hasWebp = function hasWebp(cb) {
                cb && cb(support);
                return support;
            };
            return _hasWebp(callback);
        };
    };
    var img = new Image();
    img.onload = handleOnLoad(true);
    img.onerror = handleOnLoad(false);
    img.src = 'data:image/webp;base64,UklGRkoAAABXRUJQVlA4WAoAAAAQAAAAAAAAAAAAQUxQSAsAAAABBxAREYiI/gcAAABWUDggGAAAADABAJ0BKgEAAQABABwlpAADcAD+/gbQAA==';
    return null;
};

var call = exports.call = function call(func) {
    for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
    }

    // const Promise = require('bluebird');
    if (func && typeof func === 'function') {
        var r = func.call.apply(func, [func].concat(args));
        if (r && r.then) {
            return r;
        }
        return Promise.resolve(r);
    }
    return Promise.resolve(false);
};

var _isWeiXin = function isWeiXin() {
    var result = /MicroMessenger/i.test(navigator.userAgent);
    exports.isWeiXin = _isWeiXin = function isWeiXin() {
        return result;
    };
    return _isWeiXin();
};

exports.isWeiXin = _isWeiXin;
var array = {
    fill: function fill(length, f) {
        var r = [];
        for (var x = 0; x < length; x++) {
            r.push(f);
        }
        return r;
    }
};

var _OS = function OS() {
    var os = {},
        ua = navigator.userAgent,
        android = ua.match(/(Android);?[\s\/]+([\d.]+)?/),
        iphone = !ipad && ua.match(/(iPhone\sOS)\s([\d_]+)/),
        ipod = ua.match(/(iPod)(.*OS\s([\d_]+))?/),
        ipad = ua.match(/(iPad).*OS\s([\d_]+)/);
    if (android) os.android = true, os.version = android[2];
    if (iphone && !ipod) os.ios = os.iphone = true, os.version = iphone[2].replace(/_/g, '.');
    if (ipad) os.ios = os.ipad = true, os.version = ipad[2].replace(/_/g, '.');

    _OS = function OS() {
        return os;
    };

    return _OS();
};

var string = {
    jsonToQueryString: function jsonToQueryString(json) {
        if (!json) {
            return '';
        }
        return Object.keys(json).map(function (key) {
            return encodeURIComponent(key) + '=' + encodeURIComponent(json[key]);
        }).join('&');
    }
};

var client = {
    goto: function goto(url) {
        window.location = url;
    },
    setTitle: function setTitle(title) {
        window.document.title = title;
    },

    on: function on(node, event, listener) {
        if (node.addEventListener) {
            node.addEventListener(event, listener, false);
        } else if (node.attachEvent) {
            node.attachEvent(event, listener);
        }
    },
    un: function un(node, event, listener) {
        if (node.removeEventListener) {
            node.removeEventListener(event, listener, false);
        } else if (node.detachEvent) {
            node.detachEvent(event, listener);
        }
    }
};
var DATE_S = {
    'd': 60 * 60 * 24 * 1000, //day
    'm': function m(date, num) {
        var newDate = new Date(date.getTime());
        newDate.setMonth(date.getMonth() + num);
        return newDate;
    }
};

var TIME_A = {
    'm': function m(num) {
        return num * 60;
    },
    's': function s(num) {
        return num;
    },
    'h': function h(num) {
        return num * 60 * 60;
    }
};

var WEEK_NAME = ['日', '一', '二', '三', '四', '五', '六'];

var date = {
    removeSecondText: function removeSecondText(timeText) {
        return timeText.split(':').splice(0, 2).join(':');
    },
    /**
     * 字符 1:2:1,转为秒数:1*60*60 + 2*60 + 1
     * @param time
     * @returns seconds int
     */
    time2Seconds: function time2Seconds(time) {
        var l = [60 * 60, 60];
        return time.split(':').map(function (t) {
            return parseInt(t) || 0;
        }).concat([0]).splice(0, 3).reduceRight(function (a, t, i) {
            return a + t * l[i];
        });
    },
    second2Time: function second2Time(seconds) {
        var hFloat = seconds / 3600;
        var h = parseInt(hFloat);
        var s = parseInt((hFloat - h) * 60);
        return h + ':' + number.fill(s);
    },
    week: function week(day) {
        var d = day;
        if (day instanceof Date) {
            d = day.getDay();
        }
        return WEEK_NAME[d];
    },
    new: function _new(date) {

        if (typeof date === 'string' && date.indexOf('+0800') > 0) {
            date = date.replace('+0800', '+08:00');
        }

        var d = date instanceof Date ? date : new Date(date);
        return d;
    },
    today: function today() {
        var now = new Date();
        return new Date(now.getFullYear(), now.getMonth(), now.getDate());
    },

    addTime: function addTime(time, num) {
        var s = arguments.length <= 2 || arguments[2] === undefined ? 'm' : arguments[2];

        if (typeof time === 'string') {
            if (time.indexOf(':') > -1) {
                time = this.time2Seconds(time);
            } else {
                time = parseInt(time);
            }
        }
        var added_time = time + TIME_A[s](num);

        return this.second2Time(added_time);
    },

    add: function add(date, num) {
        var s = arguments.length <= 2 || arguments[2] === undefined ? 'd' : arguments[2];

        if (num === 0) {
            return date;
        }
        var d = this.new(date); //(date instanceof Date) ? date : new Date(date);

        if (typeof DATE_S[s] === 'function') {
            return DATE_S[s](date, num);
        }

        var now = d.getTime() + num * DATE_S[s];
        // console.log(date, new Date(now), num, s);
        return new Date(now);
    },
    formatTime: function formatTime(date) {
        var d = this.new(date);
        var hour = number.fill(d.getHours());
        var minute = number.fill(d.getMinutes());
        return hour + ':' + minute;
    },
    format: function format(time) {
        var shortMonth = arguments.length <= 1 || arguments[1] === undefined ? false : arguments[1];
        var full = arguments.length <= 2 || arguments[2] === undefined ? false : arguments[2];


        var now = this.new(time); // (time instanceof Date) ? time : new Date(time);
        //let now         = new Date(time);
        var year = now.getFullYear();
        var month = now.getMonth() + 1;
        var date = now.getDate();

        if (shortMonth) {
            return number.fill(month) + '.' + number.fill(date);
        }

        var format = year + '-' + number.fill(month) + '-' + number.fill(date);

        if (full) {
            var hour = now.getHours();
            var minute = now.getMinutes();
            var second = now.getSeconds();
            // let millisecond = now.getMilliseconds();
            return format + ' ' + number.fill(hour) + ':' + number.fill(minute) + ':' + number.fill(second);
        }
        return format;
    },

    countdown: function countdown(starttime, endtime) {
        var format = arguments.length <= 2 || arguments[2] === undefined ? true : arguments[2];


        var diffSeconds = (endtime - starttime) / 1000;
        var hours = '00',
            minutes = '00',
            seconds = '00',
            milliseconds = '00';

        if (diffSeconds <= 0) {
            return { hours: hours, minutes: minutes, seconds: seconds, milliseconds: milliseconds, _empty: true };
        }

        var hoursFloat = diffSeconds / 3600;
        hours = parseInt(hoursFloat);

        var minuteFloat = (hoursFloat - hours) * 60;
        minutes = parseInt(minuteFloat);

        var secondFloat = (minuteFloat - minutes) * 60;
        seconds = parseInt(secondFloat);

        milliseconds = parseInt((secondFloat - seconds) * 1000);

        return format ? {
            hours: number.fill(hours, 2),
            minutes: number.fill(minutes, 2),
            seconds: number.fill(seconds, 2),
            milliseconds: number.fill(milliseconds, 3, '0', 2)
        } : { hours: hours, minutes: minutes, seconds: seconds, milliseconds: milliseconds };
    }
};

var number = {
    fill: function fill(number) {
        var slice = arguments.length <= 1 || arguments[1] === undefined ? 2 : arguments[1];

        var _fill = arguments.length <= 2 || arguments[2] === undefined ? '0' : arguments[2];

        var beginSlice = arguments.length <= 3 || arguments[3] === undefined ? 0 : arguments[3];

        var fills = '';

        if (String(number).length < slice) {
            var fillLength = slice - String(number).length;
            for (var i = 0; i < fillLength; i++) {
                fills += '' + _fill;
            }
        }
        fills += number;
        return beginSlice > 0 ? fills.slice(0, beginSlice) : fills.slice(-slice);
    }
};

var element = {
    hasClass: function hasClass(ele, cls) {
        return ele.className.match(new RegExp('(\\s|^)' + cls + '(\\s|$)'));
    },
    addClass: function addClass(ele, cls) {
        if (!element.hasClass(ele, cls)) ele.className += " " + cls;
    },
    removeClass: function removeClass(ele, cls) {
        if (element.hasClass(ele, cls)) {
            var reg = new RegExp('(\\s|^)' + cls + '(\\s|$)');
            ele.className = ele.className.replace(reg, ' ');
        }
    },
    toggleClass: function toggleClass(ele, cls) {
        if (element.hasClass(ele, cls)) {
            element.removeClass(obj, cls);
        } else {
            element.addClass(ele, cls);
        }
    }
};

var Noop = function Noop() {
    return false;
};

var stopEvent = function stopEvent(event) {
    if (event && event.preventDefault) {
        event.preventDefault();
        event.stopPropagation();
    }
};

var objValue = function objValue(obj, keys, value, deep) {

    if ((typeof obj === 'undefined' ? 'undefined' : _typeof(obj)) !== 'object' || typeof keys !== 'string') {
        console.log(obj, keys);
        throw new Error('Type of [obj] or [keys] is illegal');
    }

    var keyList = keys.split('.');
    var lastKey = keyList.pop();
    // let obj = obj;

    for (var i in keyList) {
        var p = keyList[i];
        if ((typeof obj === 'undefined' ? 'undefined' : _typeof(obj)) === 'object' && obj[p] === undefined) {
            if (deep) {
                obj[p] = {};
                obj = obj[p];
                continue;
            }
            return;
        }

        obj = obj[p];
    }

    var result = false;
    if ((typeof obj === 'undefined' ? 'undefined' : _typeof(obj)) === 'object') {
        obj[lastKey] = value;
        result = true;
    }
    // console.log(JSON.stringify(order));
    return result;
};

var extendObject = function extendObject(target) {
    for (var _len2 = arguments.length, sourceObj = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
        sourceObj[_key2 - 1] = arguments[_key2];
    }

    sourceObj.map(function (s) {
        for (var o in s) {
            target[o] = s[o];
        }
    });
};

var X = {
    Noop: Noop,
    stopEvent: stopEvent,
    hasWebp: _hasWebp,
    call: call,
    isWeiXin: _isWeiXin,
    window: client,
    date: date,
    number: number,
    string: string,
    element: element,
    array: array,
    objValue: objValue,
    extendObject: extendObject,
    OS: _OS
};
//
//(()=> {
//    X.window.on(window, 'hashchange', (r)=> {
//        console.log(r);
//    });
//})();


exports.default = X;