'use strict';
/*global XR */

/**
 * Created by x.Laoxu on 4/30/16.
 */

Object.defineProperty(exports, "__esModule", {
    value: true
});
var ApiError = function ApiError(error) {
    var stack;
    this.message = error.err_msg;
    this.name = 'ApiError';
    this.code = error.err_code || -1;
    this.originalError = error;

    if (Error.captureStackTrace) {
        Error.captureStackTrace(this, this.constructor);
        stack = this.stack;
    } else {
        stack = new Error(this.message).stack;
    }

    if (Object.defineProperty) {
        Object.defineProperty(this, 'stack', {
            get: function get() {
                if (this.originalError) {
                    return stack + '\nCaused by:  ' + this.originalError.stack;
                }

                return stack;
            }
        });
    }
};

ApiError.prototype = new Error();
ApiError.prototype.constructor = ApiError;

exports.default = ApiError;