'use strict';
/*global XR*/

/**
 * Created by x.Laoxu on 10/09/2016.
 */

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _beginLoad = void 0,
    _endLoad = void 0,
    _loadingComponent = void 0;

var asyncLoadComponentBundle = function asyncLoadComponentBundle(bundle) {
    return function (cb) {
        // console.log('begin:');
        _beginLoad && _beginLoad();
        bundle(function (component) {
            component = component && (component.default || component);
            // console.log('end:');
            _endLoad && _endLoad();
            cb(component);
        });
    };
};

var AsyncLoadComponentMixin = {
    loadedComponent: null,
    __remote_load: function __remote_load() {
        if (this.constructor.loadedComponent) {
            return;
        }

        this.bundle(function (component) {
            this.constructor.loadedComponent = component;
            this.forceUpdate();
        }.bind(this));
    },

    componentDidMount: function componentDidMount() {
        this.__remote_load();
    },

    render: function render() {
        var Component = this.constructor.loadedComponent;
        if (Component) {
            return _react2.default.createElement(Component, this.props);
        }
        return this.preRender();
    }
};

var asyncLoad = function asyncLoad(component_path) {
    return _react2.default.createClass({
        mixins: [AsyncLoadComponentMixin],
        bundle: asyncLoadComponentBundle(component_path),
        preRender: function preRender() {
            // const LoadingComponent = _loadingComponent;
            //return LoadingComponent ? <LoadingComponent/> : false;
            return _loadingComponent || false;
        }
    });
};

var init = function init(loadingComponent, beginLoad, endLoad) {
    _loadingComponent = loadingComponent;
    _beginLoad = beginLoad;
    _endLoad = endLoad;
};

exports.default = {
    init: init,
    load: asyncLoad
};