'use strict';
/*global XR */

/**
 * Created by x.Laoxu on 4/30/16.
 */

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _superagent = require('superagent');

var _superagent2 = _interopRequireDefault(_superagent);

var _superagentJsonp = require('superagent-jsonp');

var _superagentJsonp2 = _interopRequireDefault(_superagentJsonp);

var _superagentBluebirdPromise = require('superagent-bluebird-promise');

var _superagentBluebirdPromise2 = _interopRequireDefault(_superagentBluebirdPromise);

var _ApiError = require('./ApiError');

var _ApiError2 = _interopRequireDefault(_ApiError);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var makeRequest = function makeRequest() {
    var method = arguments.length <= 0 || arguments[0] === undefined ? 'get' : arguments[0];
    var url = arguments.length <= 1 || arguments[1] === undefined ? '' : arguments[1];
    var query = arguments[2];
    var headers = arguments[3];


    var req = _superagentBluebirdPromise2.default[method](url.indexOf('http') === 0 ? url : base_url + url).withCredentials();

    if (query) {
        var baseQuery = {}; //Account.getBaseQuery();
        // baseQuery['__v'] = Config.version;
        var queryPackage = query ? Object.assign(Object.assign({}, query), baseQuery) : baseQuery;

        req.query(queryPackage);
    }

    headers && Object.keys(headers).map(function (key) {
        req.set(key, headers[key]);
    });

    return req;
};

var makePromise = function makePromise(request) {
    processBeginHandler && processBeginHandler();
    return request.promise().then(function (res) {
        processEndHandler && processEndHandler();
        // console.log(res);
        // console.log(res.text);
        // console.log(res);
        if (res && res.text) {
            return JSON.parse(res.text);
        }
        return res.text;
    }).catch(_superagent2.default.SuperagentPromiseError, function (err) {
        // console.log(err);
        processEndHandler && processEndHandler();
        var body = err.body;

        if (body && (typeof body === 'undefined' ? 'undefined' : _typeof(body)) === 'object') {
            throw new _ApiError2.default(body);
        }
    });
};
var processBeginHandler = void 0,
    processEndHandler = void 0;

var _setProcessHandler = function _setProcessHandler(begin, end) {
    processBeginHandler = begin;
    processEndHandler = end;
};

var http = {
    _setProcessHandler: _setProcessHandler,
    jsonp: function jsonp(url) {
        return new Promise(function (resolve, reject) {
            makeRequest('get', url).use((0, _superagentJsonp2.default)({ timeout: 3000 })).end(function (err, res) {
                // console.log(err, res);
                if (res && res.body) {
                    resolve(res.body);
                } else {
                    reject(err);
                }
            });
        });
    },
    Get: function Get(url, headers, query) {
        var req = makeRequest('get', url, query, headers);
        return makePromise(req);
    },
    Post: function Post(url, headers, body, query) {
        var req = makeRequest('post', url, query, headers);
        if (!headers['Content-Type']) {
            req.set('Content-Type', 'application/x-www-form-urlencoded');
        }
        req.send(body);
        return makePromise(req);
    }
};
exports.default = http;