'use strict';

/**
 * Created by x on 12/14/15.
 */

Object.defineProperty(exports, "__esModule", {
    value: true
});
var FIX_NAME = 'FT_';

var _getLocalStorage = function _getLocalStorage() {
    if (!localStorage) {
        throw new Error('Need localStorage');
    }
    return localStorage;
};

var _formatKey = function _formatKey(key) {
    return FIX_NAME + key;
};

//保存值
var save = function save(key, value) {

    if (value === undefined) {
        value = null;
    }

    var _key = _formatKey(key);

    var localStorage = _getLocalStorage();
    //console.log('save', _key, value);
    try {
        localStorage[_key] = JSON.stringify(value);
        localStorage[_key + '_overpass'] = new Date().getTime();
    } catch (err) {
        //console.log(err);
    }
};

//获得
var _getValue = function _getValue(key) {
    var localStorage = _getLocalStorage();
    var _key = _formatKey(key);

    var _value = localStorage[_key];

    //console.log('load', _key, value);
    if (_value) {
        try {
            return JSON.parse(_value);
        } catch (err) {
            //console.error(err);
        }
    }
    return null;
};

var load = function load(key, timeout, callback) {

    //console.log('load', _key);
    var saver = function saver(value) {
        save(key, value);
    };

    var localStorage = _getLocalStorage();

    if (timeout == -1) {
        return callback && callback(null, saver);
    }

    var _key = _formatKey(key);
    if (timeout) {
        var _key_overpass = localStorage[_key + '_overpass'] || 0;

        //是否过期
        if (!_key_overpass || new Date() - _key_overpass > timeout) {
            //console.log('timeout', _key, (new Date() - _key_overpass));

            return callback && callback(null, saver);
        }
    }

    var _value = _getValue(key);
    //console.log('DB', _key, _value);

    callback && callback(_value, saver);

    return _value;
};

var DB = {
    save: save,
    load: load,
    get: _getValue
};

exports.default = DB;