'use strict';

/**
 * Created by x.Laoxu on 4/27/16.
 */

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mixins = require('./mixins');

var _mixins2 = _interopRequireDefault(_mixins);

var _ReactStateMagicMixin = require('./alt/ReactStateMagicMixin');

var _ReactStateMagicMixin2 = _interopRequireDefault(_ReactStateMagicMixin);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var create = function create(cls) {
    var pure = arguments.length <= 1 || arguments[1] === undefined ? false : arguments[1];

    initAltStore(cls);
    _mixins2.default.addMixins(cls, _mixins2.default.CreateMixin); //run:0

    if (!pure) {
        _mixins2.default.addMixins(cls, _mixins2.default.getContextMixin(cls.contextTypes)); //run:1
    }

    // Mixins.appendMixins(cls, Mixins.InitMixin);//run:last
    return _react2.default.createClass(cls);
};

var initAltStore = function initAltStore(cls) {
    if (!cls.store) {
        return;
    }

    cls.statics = Object.assign(cls.statics || {}, {
        registerStore: cls.store
    });
    _mixins2.default.addMixins(cls, _ReactStateMagicMixin2.default);
};

var appCreateMixin = function appCreateMixin() {

    return {
        childContextTypes: {
            App: _react2.default.PropTypes.object,
            R: _react2.default.PropTypes.object
        },

        getChildContext: function getChildContext() {
            // console.log('getChildContext');
            return {
                App: this,
                R: this.R
            };
        },
        getInitialState: function getInitialState() {
            // console.log('AppMixin getInitialState');
            this.R = XR.L.R;
            // init && init.call(this,this);
            return {};
        }
    };
};

var createApp = function createApp(cls) {
    _mixins2.default.addMixins(cls, appCreateMixin(cls.init));
    return create(cls);
};

exports.default = {
    addMixins: _mixins2.default.addMixins,
    appendMixins: _mixins2.default.appendMixins,
    create: create,
    createApp: createApp
};