'use strict';

/**
 * Created by x.Laoxu on 4/27/16.
 */

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var addMixins = function addMixins(cls) {
    for (var _len = arguments.length, mixin = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        mixin[_key - 1] = arguments[_key];
    }

    cls.mixins = [].concat(mixin).concat(cls.mixins || []);
};

var appendMixins = function appendMixins(cls) {
    for (var _len2 = arguments.length, mixin = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
        mixin[_key2 - 1] = arguments[_key2];
    }

    cls.mixins = (cls.mixins || []).concat([].concat(mixin));
};

var ContextTypes = {
    App: _react2.default.PropTypes.object,
    R: _react2.default.PropTypes.object
};

var CreateMixin = {
    getInitialState: function getInitialState() {
        this._create && this._create();
        return null;
    }
};

// const InitMixin = {
//     getInitialState(){
//         this._init && this._init();
//         return null;

//     }
// };


var getContextMixin = function getContextMixin(contextTypes) {
    contextTypes && console.log('getContextMixin', contextTypes);
    return {
        contextTypes: Object.assign({}, ContextTypes, contextTypes),
        getInitialState: function getInitialState() {

            this.App = this._getContext('App');
            this.R = this._getContext('R');

            for (var n in contextTypes) {
                this[n] = this._getContext(n);
            }
            return null;
        },

        _getContext: function _getContext(name) {
            return this.context[name];
        }
    };
};

var Mixins = {
    addMixins: addMixins,
    appendMixins: appendMixins,
    CreateMixin: CreateMixin,
    // InitMixin,
    getContextMixin: getContextMixin
};

exports.default = Mixins;