'use strict';
/*global XR*/

/**
 * Created by x.Laoxu on 10/09/2016.
 */
import React from 'react';

let _beginLoad, _endLoad, _loadingComponent;


const asyncLoadComponentBundle = bundle => (cb) => {
    // console.log('begin:');
    _beginLoad && _beginLoad();
    bundle(component => {
        component = component && (component.default || component);
        // console.log('end:');
        _endLoad && _endLoad();
        cb(component);
    });
};

const AsyncLoadComponentMixin = {
    loadedComponent: null,
    __remote_load: function () {
        if (this.constructor.loadedComponent) {
            return;
        }

        this.bundle(function (component) {
            this.constructor.loadedComponent = component;
            this.forceUpdate();
        }.bind(this));
    },

    componentDidMount: function () {
        this.__remote_load();
    },

    render: function () {
        let Component = this.constructor.loadedComponent;
        if (Component) {
            return <Component {...this.props}/>;
        }
        return this.preRender();
    }
};

const asyncLoad = (component_path) => {
    return React.createClass({
        mixins: [AsyncLoadComponentMixin],
        bundle: asyncLoadComponentBundle(component_path),
        preRender: function () {
            // const LoadingComponent = _loadingComponent;
            //return LoadingComponent ? <LoadingComponent/> : false;
            return _loadingComponent || false;
        }
    });
};

const init = (loadingComponent, beginLoad, endLoad) => {
    _loadingComponent = loadingComponent;
    _beginLoad = beginLoad;
    _endLoad = endLoad;
};

export default {
    init,
    load: asyncLoad
}