'use strict';
/*global XR */

/**
 * Created by x.Laoxu on 4/30/16.
 */
import superagent from 'superagent';
import jsonp from 'superagent-jsonp';
import request from 'superagent-bluebird-promise';
import ApiError from './ApiError';

let makeRequest = (method = 'get', url = '', query, headers)=> {

    let req = request[method](url.indexOf('http') === 0 ? url : base_url + url).withCredentials();

    if (query) {
        let baseQuery = {}//Account.getBaseQuery();
        // baseQuery['__v'] = Config.version;
        let queryPackage = query ? Object.assign(Object.assign({}, query), baseQuery) : baseQuery;

        req.query(queryPackage);
    }


    headers && Object.keys(headers).map(key=> {
        req.set(key, headers[key]);
    });

    return req;
};

let makePromise = (request)=> {
    processBeginHandler && processBeginHandler();
    return request.promise().then((res)=> {
        processEndHandler && processEndHandler();
        // console.log(res);
        // console.log(res.text);
        // console.log(res);
        if (res && res.text) {
            return JSON.parse(res.text);
        }
        return res.text;
    }).catch(superagent.SuperagentPromiseError, err=> {
        // console.log(err);
        processEndHandler && processEndHandler();
        const body = err.body;

        if (body && typeof body === 'object') {
            throw new ApiError(body)
        }
    });
};
let processBeginHandler,
    processEndHandler;

const _setProcessHandler = (begin, end)=> {
    processBeginHandler = begin;
    processEndHandler = end;
};

let http = {
    _setProcessHandler,
    jsonp: (url)=> {
        return new Promise((resolve, reject)=> {
            makeRequest('get', url).use(jsonp({timeout: 3000})).end(function (err, res) {
                // console.log(err, res);
                if (res && res.body) {
                    resolve(res.body);
                }
                else {
                    reject(err);
                }
            });
        });
    },
    Get: (url, headers, query)=> {
        let req = makeRequest('get', url, query, headers);
        return makePromise(req);
    },
    Post: (url, headers, body, query)=> {
        let req = makeRequest('post', url, query, headers);
        if (!headers['Content-Type']) {
            req.set('Content-Type', 'application/x-www-form-urlencoded');
        }
        req.send(body);
        return makePromise(req);
    }
};
export default http;