'use strict';

/**
 * Created by x on 12/14/15.
 */

const FIX_NAME = 'FT_';

let _getLocalStorage = ()=> {
    if (!localStorage) {
        throw new Error('Need localStorage');
    }
    return localStorage;
};

let _formatKey = (key)=> {
    return FIX_NAME + key;
};

//保存值
const save = (key, value)=> {

    if (value === undefined) {
        value = null;
    }

    let _key = _formatKey(key);

    let localStorage = _getLocalStorage();
    //console.log('save', _key, value);
    try {
        localStorage[_key]               = JSON.stringify(value);
        localStorage[_key + '_overpass'] = new Date().getTime();
    }
    catch (err) {
        //console.log(err);
    }
};

//获得
const _getValue = (key)=> {
    let localStorage = _getLocalStorage();
    let _key         = _formatKey(key);

    let _value = localStorage[_key];

    //console.log('load', _key, value);
    if (_value) {
        try {
            return JSON.parse(_value);
        }
        catch (err) {
            //console.error(err);
        }
    }
    return null;
};

const load = (key, timeout, callback)=> {


    //console.log('load', _key);
    let saver = (value)=> {
        save(key, value);
    };

    let localStorage = _getLocalStorage();

    if (timeout == -1) {
        return callback && callback(null, saver);
    }

    let _key = _formatKey(key);
    if (timeout) {
        let _key_overpass = localStorage[_key + '_overpass'] || 0;

        //是否过期
        if (!_key_overpass || (new Date() - _key_overpass) > timeout) {
            //console.log('timeout', _key, (new Date() - _key_overpass));

            return callback && callback(null, saver);
        }
    }

    let _value = _getValue(key);
    //console.log('DB', _key, _value);

    callback && callback(_value, saver);

    return _value;
};


const DB = {
    save,
    load,
    get: _getValue
};

export default DB;