'use strict';

/**
 * Created by x on 12/1/15.
 */

class RouteHandler {
    constructor() {
        this.historyListener = [];
        this.location        = null;
    }

    setEntryLocation(location) {
        this.entry            = location;
        //console.log('entry', this.entry);
        this.setEntryLocation = ()=>null;
    }

    //url_config 表示router中URL_CONFIG
    init(history, url_config) {
        this.history = history;

        this._to  = {};
        this._get = url_config;
        //枚举路由设置对象URL_GETTER
        Object.keys(this._get).map(n=> {
            //扩展this._to对象 列子: this.to.period
            this._to[n] = (...args)=> {
                this._toInvoke(n, ...args);
            };
        });


        this._gobackFix();

        this.history.listen((location)=> {
            this.setEntryLocation(location);
            this.location = location;
            this.historyListener.forEach(listener=> {
                setTimeout(()=>listener(location), 0);
            });
        });
    }

    _gobackFix() {
        this.length        = 0;
        this.urlBackHandle = location => {
            //console.log(this.length);
            if (location.action === 'POP') {
                this.length = Math.max(--this.length, 0);
            }
            else {
                this.length++;
            }
            //console.log(this.length, location);
        };
        this.addListener(this.urlBackHandle);
    }

    removeListener(listener) {
        // console.log(this.historyListener.length);
        this.historyListener = this.historyListener.filter(l=>l != listener);
        // console.log(this.historyListener.length);
    }

    addListener(listener) {

        this.historyListener.push(listener);
        /**
         * 如果,this.history.listen 执行过,第一次添加时,会执行listener
         */
        if (this.location) {
            setTimeout(()=>listener(this.location), 0);
        }
    }

    _toInvoke(n, ...args) {
        let url = this._get[n](...args);
        // if (x.isWeiXin() && n == 'cart') {
        //     location.pathname = url;
        //     return;
        // }
        this.goto(url, ...args);
    }

    goIndex() {
        this.goto('/');
    }

    goto(url) {
        // console.log(url);
        // if (XSpaceHost.routeInterceptor(this.location, url)) {
        //     return false;
        // }


        if (url && url.indexOf('http') === 0) {
            x.window.goto(url);
            return;
        }
        else {

            let splistUrl = url.split('?');

            let _ = {
                pathname: splistUrl[0],
                search: (splistUrl.length == 2 ? '?' + splistUrl[1] : '')
            };

            this.history.push(_);
        }
    }

    goBack() {
        if (this.length == 0 && window.history && window.history.length > this.length) {
            this.goIndex();
            return;
        }
        this.history.goBack();
    }

    get to() {
        return this._to;
    }

    get get() {
        return this._get;
    }

    replace(url) {
        this.history.replace(url);
    }
}

const R = new RouteHandler();
export default R;
