'use strict';

/**
 * Created by x.Laoxu on 12/26/15.
 */

(function (globals) {
    if (Array.prototype.includes) {
        return;
    }
    Array.prototype.includes = function (searchElement /*, fromIndex*/) {
        'use strict';
        var O   = Object(this);
        var len = parseInt(O.length) || 0;
        if (len === 0) {
            return false;
        }
        var n = parseInt(arguments[1]) || 0;
        var k;
        if (n >= 0) {
            k = n;
        } else {
            k = len + n;
            if (k < 0) {
                k = 0;
            }
        }
        var currentElement;
        while (k < len) {
            currentElement = O[k];
            if (searchElement === currentElement ||
                (searchElement !== searchElement && currentElement !== currentElement)) { // NaN !== NaN
                return true;
            }
            k++;
        }
        return false;
    };
})(window);
(function (globals) {

    if (Array.prototype.find) return;

    var find = function (predicate) {
        var list   = Object(this);
        var length = list.length < 0 ? 0 : list.length >>> 0; // ES.ToUint32;
        if (length === 0) return undefined;
        if (typeof predicate !== 'function' || Object.prototype.toString.call(predicate) !== '[object Function]') {
            throw new TypeError('Array#find: predicate must be a function');
        }
        var thisArg = arguments[1];
        for (var i = 0, value; i < length; i++) {
            value = list[i];
            if (predicate.call(thisArg, value, i, list)) return value;
        }
        return undefined;
    };

    if (Object.defineProperty) {
        try {
            Object.defineProperty(Array.prototype, 'find', {
                value: find, configurable: true, enumerable: false, writable: true
            });
        } catch (e) {
        }
    }

    if (!Array.prototype.find) {
        Array.prototype.find = find;
    }
})(window);


(function (gloabs) {
    'use strict';
    if (Object.assign) {
        return;
    }

    var hasOwnProperty   = Object.prototype.hasOwnProperty;
    var propIsEnumerable = Object.prototype.propertyIsEnumerable;

    function toObject(val) {
        if (val === null || val === undefined) {
            throw new TypeError('Object.assign cannot be called with null or undefined');
        }

        return Object(val);
    }

    Object.assign = function (target, source) {
        var from;
        var to = toObject(target);
        var symbols;

        for (var s = 1; s < arguments.length; s++) {
            from = Object(arguments[s]);

            for (var key in from) {
                if (hasOwnProperty.call(from, key)) {
                    to[key] = from[key];
                }
            }

            if (Object.getOwnPropertySymbols) {
                symbols = Object.getOwnPropertySymbols(from);
                for (var i = 0; i < symbols.length; i++) {
                    if (propIsEnumerable.call(from, symbols[i])) {
                        to[symbols[i]] = from[symbols[i]];
                    }
                }
            }
        }

        return to;
    };


})(window);