'use strict';

/**
 * Created by x.Laoxu on 4/27/16.
 */
import React from 'react';
import Mixins from './mixins';
import ReactStateMagicMixin from './alt/ReactStateMagicMixin';


const create = (cls, pure = false) => {
    initAltStore(cls);
    Mixins.addMixins(cls, Mixins.CreateMixin);//run:0
    
    if (!pure) {
        Mixins.addMixins(cls, Mixins.getContextMixin(cls.contextTypes));//run:1
    }
    
    // Mixins.appendMixins(cls, Mixins.InitMixin);//run:last
    return React.createClass(cls);
};

const initAltStore = (cls) => {
    if (!cls.store) {
        return;
    }

    cls.statics = Object.assign(cls.statics || {}, {
        registerStore: cls.store
    });
    Mixins.addMixins(cls, ReactStateMagicMixin);

};


const appCreateMixin = () => {

    return {
        childContextTypes: {
            App: React.PropTypes.object,
            R: React.PropTypes.object
        },

        getChildContext() {
            // console.log('getChildContext');
            return {
                App: this,
                R: this.R
            };
        },

        getInitialState() {
            // console.log('AppMixin getInitialState');
            this.R = XR.L.R;
            // init && init.call(this,this);
            return {};
        }
    }
};

const createApp = (cls) => {
    Mixins.addMixins(cls, appCreateMixin(cls.init));
    return create(cls);
};



export default {
    addMixins: Mixins.addMixins,
    appendMixins: Mixins.appendMixins,
    create,
    createApp
};