'use strict';

/**
 * Created by x.Laoxu on 4/27/16.
 */

import React from 'react';

const addMixins = (cls, ...mixin)=> {
    cls.mixins = [...mixin].concat(cls.mixins || []);
};

const appendMixins = (cls, ...mixin)=> {
    cls.mixins = (cls.mixins || []).concat([...mixin]);
};



const ContextTypes = {
    App: React.PropTypes.object,
    R: React.PropTypes.object,
};

const CreateMixin = {
    getInitialState(){
        this._create && this._create();
        return null;
    }
};

// const InitMixin = {
//     getInitialState(){
//         this._init && this._init();
//         return null;

//     }
// };


const getContextMixin = (contextTypes)=> {
    contextTypes && console.log('getContextMixin',contextTypes);
    return {
        contextTypes: Object.assign({}, ContextTypes, contextTypes),
        getInitialState: function () {

            this.App = this._getContext('App');
            this.R = this._getContext('R');

            for (let n in contextTypes) {
                this[n] = this._getContext(n);
            }
            return null;
        },

        _getContext: function (name) {
            return this.context[name];
        }
    };
};

const Mixins = {
    addMixins,
    appendMixins,
    CreateMixin,
    // InitMixin,
    getContextMixin
};

export default Mixins;